<template>
  <q-layout view="lHh Lpr lFf">
    <q-header elevated>
      <q-bar class="q-electron-drag bg-light-blue-9 text-white">
        <q-icon name="laptop_chromebook" />
        <div>ForceCAST Studio</div>

        <q-space />

        <q-btn dense flat icon="minimize" @click="minimize" />
        <q-btn dense flat icon="crop_square" @click="toggleMaximize" />
        <q-btn dense flat icon="close" @click="closeApp" />
      </q-bar>

      <div class="q-pa-sm q-pl-md row items-center bg-light-blue-7">
        <div class="cursor-pointer non-selectable">
          File
          <q-menu>
            <q-list dense style="min-width: 100px">
              <q-item clickable v-close-popup @click="closeApp">
                <q-item-section>Quit</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </div>
        <div class="q-ml-md cursor-pointer non-selectable">
          Edit
          <q-menu auto-close>
            <q-list dense style="min-width: 100px">
              <q-item clickable @click="showSettings = true">
                <q-item-section>Settings</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </div>
        <div class="q-ml-md cursor-pointer non-selectable">
          Help
          <q-menu auto-close>
            <q-list dense style="min-width: 100px">
              <q-item clickable @click="show_about=true">
                <q-item-section>About</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </div>
        <!-- <div class="q-ml-md cursor-pointer non-selectable">
          Test
          <q-menu auto-close>
            <q-list dense style="min-width: 100px">
              <q-item clickable @click="$router.push('/testWSPage')">
                <q-item-section>Communication</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </div> -->
        <q-space />
        <q-breadcrumbs active-color="white">
          <template v-slot:separator>
            <q-icon size="1.2em" name="arrow_forward" color="white" />
          </template>
          <q-breadcrumbs-el
            :icon="crumb.icon"
            :label="crumb.name"
            :to="crumb.link"
            v-for="(crumb, index) in parsedRoute"
            :key="'crumb' + index"
          />
        </q-breadcrumbs>
        <q-space />
        <div @click="toSerial" style="cursor: pointer">
        <span class="text-overline text-uppercase">{{ connected ? 'Connected' : 'Disconnected' }}</span>
        <q-icon
          style="margin-left: 0.5em; margin-right: 1em"
          :name="connected ? 'mdi-lan-connect' : 'mdi-lan-disconnect'"
          size="sm"
          :color="connected ? 'white' : 'negative'"
        />
        </div>
      </div>
    </q-header>

    <q-page-container>
      <router-view />
      <settings-vue v-model:show="showSettings" v-model:tab="settingTab" />
      <AboutVue v-model:show="show_about" />
    </q-page-container>
  </q-layout>
</template>

<script lang="ts">
import SettingsVue from 'pages/Settings.vue';
import AboutVue from 'components/help/About.vue'
import { defineComponent, computed, ref } from 'vue';
import { useRoute } from 'vue-router';
import { useStore } from 'src/store';

export default defineComponent({
  name: 'MainLayout',
  components: {
    SettingsVue,
    AboutVue
  },
  setup() {
    const $store = useStore();
    const connected = computed(() => $store.state.status.connected);
    function minimize() {
      if (process.env.MODE === 'electron') {
        window.myWindowAPI.minimize();
      }
    }

    function toggleMaximize() {
      if (process.env.MODE === 'electron') {
        window.myWindowAPI.toggleMaximize();
      }
    }

    function closeApp() {
      if (process.env.MODE === 'electron') {
        window.myWindowAPI.close();
      }
    }

    const route = useRoute();

    const routePath = computed(() => route.path);

    const parsedRoute = computed(() => {
      const crumbs: Array<string> = [];
      routePath.value.split('/').forEach((element) => {
        if (element.length > 0) crumbs.push(element);
      });
      const refinedCrumbs = [{ name: 'Home', link: '/', icon: 'home' }];
      return refinedCrumbs.concat(
        crumbs.map((element) => {
          return {
            name: element.charAt(0).toUpperCase() + element.substr(1).toLowerCase(),
            link: '/' + element,
            icon: 'apps',
          };
        })
      );
      return refinedCrumbs;
    });

    const showSettings = ref(false)
    const settingTab = ref('serial');

    const toSerial = () => {
      settingTab.value = 'serial';
      showSettings.value = true;
    }

    const show_about = ref(false);

    return { minimize, toggleMaximize, closeApp, parsedRoute, showSettings, settingTab, connected, toSerial, show_about };
  },
});
</script>

<style lang="sass">
.notification
  margin-top: 6rem
</style>
